/*
Program Name: BM.PRG             Copyright: United HealthCare
Date Created: 04/25/94           Language: Clipper
Time Created: 16:16:23             Author: George Penzenik

Simple bench mark program

Version 0.9

*/
#include "x:\clip52\lib\comix\cmx52.ch"
#include "inkey.ch"
#include "dbstruct.ch"

function bm(nInput)
local aDbf[3][4]  // ARRAY DBF STRUCTURE
local nStime:=0   // Start Time
local nFtime:=0   // Finish Time
local ee:=0       // Counter
local BM          // DBF name
local doit        // Erase BM
set color to 'gr+/bg'
clear screen

// Lets keep the clown on the keyboard honest
do while val(nInput) < 1000
  accept 'Get real man! Got to be more than 999!  ' to nInput
enddo

?  'Thanks dude!  Starting test with ' + str(val(nInput)) + ' Records...'
inkey(1)

// Lets whip up a little DBF

? 'Creating BM.DBF ...'

aDbf[1][ DBS_NAME ] := [NAME]
aDbf[1][ DBS_TYPE ] := [Character]
aDbf[1][ DBS_LEN  ] := 30
aDbf[1][ DBS_DEC  ] := 0

aDbf[2][ DBS_NAME ] := [DATE]
aDbf[2][ DBS_TYPE ] := [DATE]
aDbf[2][ DBS_LEN  ] := 8
aDbf[2][ DBS_DEC  ] := 0

aDbf[3][ DBS_NAME ] := [TIME]
aDbf[3][ DBS_TYPE ] := [CHARACTER]
aDbf[3][ DBS_LEN  ] := 9
aDbf[3][ DBS_DEC  ] := 0

dbcreate('BM', aDbf)

? time()
nStime:=seconds()

use BM exclusive new
index on bm->date tag date
index on bm->time tag time descending
index on bm->name tag name

do while ee < val(nInput)
  append blank
  replace bm->name with 'Test Information'
  replace bm->date with date()
  replace bm->time with time()
  ee=ee+1
  if ee%1000 = 0
    ? ltrim(str(recno())) + ' records appended...'
  endif
enddo

?  "Done APPENDING " + str(val(nInput)) + " records"
?  time()
nFtime:=seconds()
?  'Total time = ' + ltrim(str( (nFtime - nStime) / 60 )) + ' minutes'
?  ltrim(str(val(nInput)/(nFtime - nStime))) + ' APPENDS per second'
?  'Reindexing CDX...'
nStime:=seconds()
reindex
nFtime:=seconds()
?  'Three tag CDX reindexed in ' + ltrim(str( (nFtime - nStime) / 60 )) + ' minutes'
dbcloseall()
accept 'Erase BM.DBF & BM.CDX ? ( Y/N )' to doit

if doit $ 'Yy'
ferase('bm.cdx')
ferase('bm.dbf')
endif

return nil    

